
-----------------------------------------------------------------------------------------
--
-- Copyright (c) 2009-2012 ProactiveRA
--
-- This script is free software; you can redistribute it and/or modify it under
-- the terms of the GNU Lesser General Public License as published by the Free
-- Software Foundation; either version 3 of the License, or (at your option)
-- any later version.
--
-- This script is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
-- details.
--
-- You should have received a copy of the GNU Lesser General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-----------------------------------------------------------------------------------------




DROP FUNCTION F_KPI_CDR_VALUE_PAST_MONTH;

CREATE OR REPLACE FUNCTION F_KPI_CDR_VALUE_PAST_MONTH (
	V_CP_ID IN NUMBER,
	V_ST_ID IN NUMBER,
	V_DATE IN DATE DEFAULT TRUNC(sysdate, 'MM')
  )
RETURN TYPE_KPI_RESULT_ARRAY IS
  V_COUNT NUMBER(15,4);
  V_NB_DAYS NUMBER(2);
  KPI_RESULT_ARRAY TYPE_KPI_RESULT_ARRAY:=TYPE_KPI_RESULT_ARRAY();
BEGIN

  IF (V_DATE < TRUNC(SYSDATE, 'MM')) THEN

	-- Recalculating historical value
	--SELECT ADD_MONTHS(TRUNC(V_DATE, 'MM'), 1)-TRUNC(V_DATE, 'MM')
	--INTO V_NB_DAYS
	--FROM DUAL;

  	SELECT SUM(VALUE)
	INTO V_COUNT
	FROM CDR_ALL_SUMMARY
	WHERE CONTROL_POINT_ID=V_CP_ID
	AND TRUNC(TRANS_DT, 'MM')>=TRUNC(V_DATE, 'MM')
	AND TRUNC(TRANS_DT, 'MM')< ADD_MONTHS(TRUNC(V_DATE, 'MM'), 1)
	AND SERVICE_TYPE_ID=V_ST_ID;

	-- Prorating to 30-day month
	--V_COUNT:=V_COUNT*(30/V_NB_DAYS);
  ELSE
  	SELECT SUM(VALUE)
	INTO V_COUNT
	FROM CDR_ALL_SUMMARY
	WHERE CONTROL_POINT_ID=V_CP_ID
	AND TRUNC(TRANS_DT, 'DD')>=(TRUNC(SYSDATE, 'DD')-30)
	AND TRUNC(TRANS_DT, 'DD')< TRUNC(SYSDATE, 'DD')
	AND SERVICE_TYPE_ID=V_ST_ID;
	
  END IF;

  KPI_RESULT_ARRAY.EXTEND;
  KPI_RESULT_ARRAY(1):=V_COUNT;

  RETURN KPI_RESULT_ARRAY;

END F_KPI_CDR_VALUE_PAST_MONTH;
/



