
-----------------------------------------------------------------------------------------
--
-- Copyright (c) 2009-2012 ProactiveRA
--
-- This script is free software; you can redistribute it and/or modify it under
-- the terms of the GNU Lesser General Public License as published by the Free
-- Software Foundation; either version 3 of the License, or (at your option)
-- any later version.
--
-- This script is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
-- details.
--
-- You should have received a copy of the GNU Lesser General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-----------------------------------------------------------------------------------------



DROP PROCEDURE P_KPI_ROLLBACK;

CREATE OR REPLACE PROCEDURE P_KPI_ROLLBACK(
	V_KPI_ID IN NUMBER)
IS
  COMMAND_LINE VARCHAR2(3000);
  V_DYNA_PARAM_TYPE    NUMBER(1); -- 1=Integer, 2=Date
  V_DYNA_PARAM_VAL VARCHAR2(35); 
  V_DYNA_PARAM_FORMAT  VARCHAR2(20); 
  TYPE T_DYN_CURSOR IS REF CURSOR;
  C1 T_DYN_CURSOR;
BEGIN

  SELECT SQL_DYNA_PARAM_TYPE,
         SQL_DYNA_PARAM_FORMAT
  INTO  V_DYNA_PARAM_TYPE,
        V_DYNA_PARAM_FORMAT
  FROM REF_KPI_DEFINITION
  WHERE KPI_ID=V_KPI_ID;


  -- Calculate the new dynamic parameter value to be used

  IF (V_DYNA_PARAM_TYPE = 1) THEN
	COMMAND_LINE:='SELECT TO_NUMBER(PREVIOUS_PARAM_USED)-1';
	COMMAND_LINE:=COMMAND_LINE || ' FROM KPI_CALCULATED_VALUES ';
	COMMAND_LINE:=COMMAND_LINE || ' WHERE KPI_ID=' || TO_CHAR(V_KPI_ID);
  END IF; 
  IF (V_DYNA_PARAM_TYPE = 2) THEN
	COMMAND_LINE:='SELECT ';
	COMMAND_LINE:=COMMAND_LINE || 'TO_CHAR(TO_DATE(PREVIOUS_PARAM_USED, ''';
	COMMAND_LINE:=COMMAND_LINE || V_DYNA_PARAM_FORMAT || ''')' || '-1, ';
	COMMAND_LINE:=COMMAND_LINE || '''' || V_DYNA_PARAM_FORMAT || ''')';
	COMMAND_LINE:=COMMAND_LINE || ' FROM KPI_CALCULATED_VALUES ';
	COMMAND_LINE:=COMMAND_LINE || ' WHERE KPI_ID=' || TO_CHAR(V_KPI_ID);
  END IF;


  IF (V_DYNA_PARAM_TYPE != 3) THEN
	  OPEN C1 FOR COMMAND_LINE;
		FETCH C1 INTO V_DYNA_PARAM_VAL;
	  CLOSE C1;

	  DELETE KPI_CALCULATED_VALUES_HISTORY
	  WHERE KPI_ID=V_KPI_ID
	  AND PARAM_USED=(SELECT PARAM_USED
			  FROM KPI_CALCULATED_VALUES
			  WHERE KPI_ID=V_KPI_ID
			 );

	  UPDATE KPI_CALCULATED_VALUES
	  SET    CALCULATED_VALUE=PREVIOUS_VALUE,
		 PARAM_USED=PREVIOUS_PARAM_USED,
		 PREVIOUS_VALUE=(SELECT CALCULATED_VALUE
				 FROM KPI_CALCULATED_VALUES_HISTORY 
				 WHERE KPI_ID=V_KPI_ID
				 AND PARAM_USED=V_DYNA_PARAM_VAL),
		 PREVIOUS_PARAM_USED=V_DYNA_PARAM_VAL,
		 EVOLUTION_FLAG=0
	  WHERE KPI_ID=V_KPI_ID;

	  UPDATE KPI_CALCULATED_VALUES
	  SET EVOLUTION_FLAG=1
	  WHERE KPI_ID=V_KPI_ID
	  AND   CALCULATED_VALUE > PREVIOUS_VALUE;

	  UPDATE KPI_CALCULATED_VALUES
	  SET EVOLUTION_FLAG=-1
	  WHERE KPI_ID=V_KPI_ID
	  AND   CALCULATED_VALUE < PREVIOUS_VALUE;


	  COMMIT;

  END IF;

END;
/

