
-----------------------------------------------------------------------------------------
--
-- Copyright (c) 2009-2012 ProactiveRA
--
-- This script is free software; you can redistribute it and/or modify it under
-- the terms of the GNU Lesser General Public License as published by the Free
-- Software Foundation; either version 3 of the License, or (at your option)
-- any later version.
--
-- This script is distributed in the hope that it will be useful, but WITHOUT
-- ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-- FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
-- details.
--
-- You should have received a copy of the GNU Lesser General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-----------------------------------------------------------------------------------------



DROP TABLE REF_KPI_DEFINITION CASCADE CONSTRAINTS ; 

CREATE TABLE REF_KPI_DEFINITION ( 
  KPI_ID     	  	 NUMBER(6),
  KPI_NAME     		 VARCHAR2(80), 
  VALUE_FORMAT 		 VARCHAR2(15),
  EXECUTION_FREQUENCY	 NUMBER(2),  -- 1=Daily, 2=Weekly, 3=Monthly, 4=After each PI load
  SQL_EXEC_FUNCTION	 VARCHAR2(60),
  SQL_EXEC_PARAM	 VARCHAR2(300),
  SQL_DYNA_PARAM_NAME	 VARCHAR2(35),
  SQL_DYNA_PARAM_TYPE	 NUMBER(1), -- 1=Integer, 2=Date, 3=Platform Load Nbr, 4=Date (Store 1 value per week), 5=Date (Store 1 value per month)
  SQL_DYNA_PARAM_FORMAT  VARCHAR2(20), 
  GREEN_MIN		 NUMBER(30,4),
  GREEN_MAX		 NUMBER(30,4),
  ORANGE_MIN		 NUMBER(30,4),
  ORANGE_MAX		 NUMBER(30,4),
  RED_MIN		 NUMBER(30,4),
  RED_MAX		 NUMBER(30,4),
  RANGE_FORMAT 		 VARCHAR2(15),
  ACTIVE		 NUMBER(1),
  RECALCULATION_WINDOW	 NUMBER(3),
  KPI_DEFINITION	 CLOB
);



